#!/usr/bin/env node
import t from "chalk";
import { execSync as l } from "node:child_process";
import g, { resolve as P } from "node:path";
import u, { existsSync as N, rmSync as d } from "node:fs";
import a from "prompts";
import { getConfigPath as _, batchHandler as S } from "@done-coding/cli-template";
import { lookForParentTarget as U } from "@done-coding/node-tools";
import { getTargetRepoUrl as b } from "@done-coding/cli-git";
import I from "yargs";
import { hideBin as L } from "yargs/helpers";
const p = {
  version: "0.7.0",
  name: "create-done-coding",
  description: "项目创建命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "create"
  }
}, F = "git@gitee.com:justsosu/done-coding-cli-config-json.git", C = "自定义模版路径", j = "某个git平台用户仓库", A = `./.${p.name}_temp`;
let w;
const H = async () => (w || (w = (await k()).templateList), w), $ = async () => [
  ...await H(),
  { name: C },
  { name: j }
], R = {
  type: "text",
  name: "projectName",
  message: "请输入项目名称",
  validate: (e) => e.trim().length > 0 || "项目名称不能为空"
}, T = async () => ({
  type: "select",
  name: "template",
  message: "请选择模板",
  choices: (await $()).map((i) => ({
    title: i.name,
    value: i.name
  }))
}), M = {
  type: "confirm",
  name: "saveGitHistory",
  message: "是否保留git历史",
  initial: !1
}, E = (e = "项目已存在，是否删除") => ({
  type: "confirm",
  name: "isRemove",
  message: e
}), k = async () => {
  console.log(t.blue("拉取模板列表，请稍等..."));
  const e = g.resolve(
    process.cwd(),
    A
  );
  if (console.log(t.blue(`配置临时目录：${e}`)), u.existsSync(e)) {
    const o = `${e}目录已存在，是否删除？`, { isRemove: r } = await a(E(o));
    r ? u.rmSync(e, { recursive: !0, force: !0 }) : (console.log(t.red(`${e}已存在，请手动删除后再试！`)), process.exit(1));
  }
  l(`git clone ${F} ${e} --depth=1`);
  const i = p.name, c = g.resolve(e, `${i}.json`), v = JSON.parse(u.readFileSync(c, "utf-8"));
  if (!Array.isArray(v.templateList))
    throw new Error("远程配置文件出错，templateList 不是数组");
  return console.log(t.green("模板列表拉取成功！")), u.rmSync(e, { recursive: !0, force: !0 }), v;
}, G = async (e) => {
  const { projectName: i, template: c } = e, o = ((i ?? (await a(R)).projectName) || "").trim();
  if (!o.trim()) {
    console.log(t.red("项目名称不能为空"));
    return;
  }
  if (o.includes(" ") || o.includes("\\") || o.includes("/")) {
    console.log(t.red("项目名称不能包含空格或者\\或者/"));
    return;
  }
  const r = P(process.cwd(), o);
  if (N(r)) {
    const { isRemove: s } = await a(E());
    if (s === !0)
      d(r, { recursive: !0, force: !0 });
    else
      return console.log(t.red("项目已存在")), process.exit(1);
  }
  const m = c ?? (await a(await T())).template;
  let f = "";
  if (m === C) {
    const { customUrl: s } = await a({
      type: "text",
      name: "customUrl",
      message: "请输入自定义模板路径"
    });
    f = s;
  }
  if (m === j)
    f = await b();
  else {
    const s = (await $()).find(
      (n) => n.name === m
    );
    if (!s)
      return console.log(t.red(`模板${m}不存在`)), process.exit(1);
    if (!s.url)
      return console.log(t.red(`模板${m}仓库地址不存在`)), process.exit(1);
    f = s.url;
  }
  const y = U(".git");
  console.log(t.green("正在初始化项目，请稍等...")), l(`git clone ${f} ${o} --depth=1`);
  const h = _(r);
  if (h) {
    await S({
      rootDir: r,
      extraEnvData: {
        $projectName: o
      }
    });
    const { isRemoveTemplateConfig: s } = await a({
      type: "confirm",
      name: "isRemoveTemplateConfig",
      message: `已成功将模板项目配置注入到当前项目，是否删除模板项目配置文件(${h})`,
      initial: !0
    });
    s && d(h, { force: !0 });
  }
  if (console.log(t.green("项目初始化完成")), y) {
    const s = g.resolve(r), n = g.resolve(s, ".git");
    if (!N(n))
      throw new Error("git目录不存在");
    const { isRemoveGit: O } = await a({
      type: "confirm",
      name: "isRemoveGit",
      message: `项目创建在父级git仓库${y}中，是否删除${o}目录下的.git(${n})`,
      initial: !0
    });
    O ? (d(n, { recursive: !0, force: !0 }), console.log(t.green("已删除当前项目git目录"))) : console.log(
      t.yellow(
        `项目创建在父级git仓库${y}中，请手动删除${o}目录下的.git(${n})，否则会影响后续的git操作`
      )
    );
  } else {
    if ((await a(M)).saveGitHistory)
      l(
        `cd ${r} && git remote rename origin upstream && git fetch --unshallow`
      ), console.log(
        t.green(
          "已经将origin重命名为upstream，后续可以与模板git仓库有完整的交互"
        )
      ), console.log(
        t.green("已保存git历史记录，后续可以与模板git仓库有完整的交互")
      );
    else {
      const n = g.resolve(r, ".git");
      d(n, { recursive: !0, force: !0 }), l(`cd ${r} && git init`);
    }
    l(
      `cd ${r} && git add . && git commit -m '初始化${o}'`
    );
  }
  console.log(
    t.blue(`
使用步骤: 
  1. cd ${o}
  2. pnpm install
  3. pnpm run dev
  `)
  );
}, B = async () => ({
  projectName: {
    type: "string",
    alias: "p",
    describe: R.message
  },
  template: {
    type: "string",
    alias: "t",
    choices: (await $()).map((e) => e.name),
    describe: (await T()).message
  }
}), x = p.cliConfig.moduleName, Y = (e, i) => {
  console.log(e ? t.red(e) : t.red(i.message)), process.exit(1);
}, J = p.description, q = `Usage: $0 ${x} [options]`, z = "Usage: $0 [options]", D = async (e, i) => {
  const c = await B();
  return e.strict().usage(i).help("help").version(p.version).alias("v", "version").alias("h", "help").options(c).fail(Y).argv;
}, K = (e) => D(e, q), re = {
  command: x,
  describe: J,
  builder: K,
  handler: G
}, ne = async () => {
  const e = I(L(process.argv)), i = await D(e, z);
  return G(i);
};
export {
  re as a,
  ne as c,
  G as h
};
